<?php
	 
	function remove_signs($name, $charset = 1)
	{
	    global $modSettings, $context, $txt;

		$name = preg_replace('/^' . preg_quote($txt['response_prefix']) . '/', '', $name);

	    //$name=unhtmlentities($name);
	    //$name = strtr($name,array('&euro;'=>'euro','&#8364;'=>'euro');
	    $name = strtr($name, array('£' => 'pound', '¢' => 'cent', '°' => 'degrees', '½' => 'half', '¼' => 'quarter', '¾' => 'three-qurters', '¥' => 'yen'));
	     
	    $html_entities = array(
	    '&#196;' => 'a', '&#197;' => 'a',
	        '&#199;' => 'c', '&#201;' => 'e',
	        '&#209;' => 'n', '&#214;' => 'o',
	        '&#220;' => 'u', '&#225;' => 'a',
	        '&#224;' => 'a', '&#226;' => 'a',
	        '&#228;' => 'a', '&#227;' => 'a',
	        '&#229;' => 'a', '&#231;' => 'c',
	        '&#233;' => 'e', '&#232;' => 'e',
	        '&#234;' => 'e', '&#235;' => 'e',
	        '&#237;' => 'i', '&#236;' => 'i',
	        '&#238;' => 'i', '&#239;' => 'i',
	        '&#241;' => 'n', '&#243;' => 'o',
	        '&#242;' => 'o', '&#244;' => 'o',
	        '&#246;' => 'o', '&#245;' => 'o',
	        '&#250;' => 'u', '&#249;' => 'u',
	        '&#251;' => 'u', '&#252;' => 'u',
	        '&#192;' => 'a', '&#195;' => 'a',
	        '&#213;' => 'o', '&#338;' => 'oe',
	        '&#339;' => 'oe', '&#255;' => 'y',
	        '&#376;' => 'y', '&#194;' => 'a',
	        '&#202;' => 'e', '&#193;' => 'a',
	        '&#203;' => 'e', '&#200;' => 'e',
	        '&#205;' => 'i', '&#206;' => 'i',
	        '&#207;' => 'i', '&#204;' => 'i',
	        '&#211;' => 'o', '&#212;' => 'o',
	        '&#210;' => 'o', '&#218;' => 'u',
	        '&#219;' => 'u', '&#217;' => 'u',
	        '&#305;' => 'i', '&#352;' => 's',
	        '&#353;' => 's',
	        '&#8222;' => '', '&#8220;' => '', //special quotes
		'&#8211;' => '', '&#8217;' => '',
		'&#1567;' => '', //arabic question mark
	        );
	     
	    $name = strtr($name, $html_entities);
	     
	    if ($charset == 1)
	    {
	        if ($modSettings['seo4smf_accented_enable'] == "on")
	        {
	            if ($context['character_set'] == "UTF-8")
	            {
	                 
	                if ($modSettings['seo4smf_utf8_language'] == 1) //german translation
	                {
	                    $chars = array (
	                    chr(195).chr(132) => 'AE', chr(195).chr(164) => 'ae',
	                        chr(195).chr(150) => 'OE', chr(195).chr(182) => 'oe',
	                        chr(195).chr(156) => 'UE', chr(195).chr(188) => 'ue',
	                        );
	                    $name = strtr($name, $chars);
	                }

	                if ($modSettings['seo4smf_utf8_language'] == 2) //greek translation
	                {
	                    $chars = array (
			chr(206).chr(145) => 'A',chr(206).chr(134) => 'A',
			chr(225).chr(188).chr( 136) => 'A',chr(225).chr(188).chr( 137) => 'A',
			chr(225).chr(188).chr( 138) => 'A',chr(225).chr(188).chr( 139) => 'A',
			chr(225).chr(188).chr( 140) => 'A',chr(225).chr(188).chr( 141) => 'A',
			chr(225).chr(188).chr( 142) => 'A',chr(225).chr(188).chr( 143) => 'A',
			chr(225).chr(190).chr( 136) => 'A',chr(225).chr(190).chr( 137) => 'A',
			chr(225).chr(190).chr( 138) => 'A',chr(225).chr(190).chr( 139) => 'A',
			chr(225).chr(190).chr( 140) => 'A',chr(225).chr(190).chr( 141) => 'A',
			chr(225).chr(190).chr( 142) => 'A',chr(225).chr(190).chr( 143) => 'A',
			chr(225).chr(190).chr( 184) => 'A',chr(225).chr(190).chr( 185) => 'A',
			chr(225).chr(190).chr( 186) => 'A',chr(225).chr(190).chr( 187) => 'A',
			chr(225).chr(190).chr( 188) => 'A',chr(206).chr(146) => 'B',
			chr(206).chr(147) => 'G',chr(206).chr(148) => 'D',
			chr(206).chr(149) => 'E',chr(206).chr(136) => 'E',
			chr(225).chr(188).chr( 152) => 'E',chr(225).chr(188).chr( 153) => 'E',
			chr(225).chr(188).chr( 154) => 'E',chr(225).chr(188).chr( 155) => 'E',
			chr(225).chr(188).chr( 156) => 'E',chr(225).chr(188).chr( 157) => 'E',
			chr(225).chr(191).chr( 137) => 'E',chr(225).chr(191).chr( 136) => 'E',
			chr(206).chr(150) => 'Z',chr(206).chr(151) => 'I',
			chr(206).chr(137) => 'I',chr(225).chr(188).chr( 168) => 'I',
			chr(225).chr(188).chr( 169) => 'I',chr(225).chr(188).chr( 170) => 'I',
			chr(225).chr(188).chr( 171) => 'I',chr(225).chr(188).chr( 172) => 'I',
			chr(225).chr(188).chr( 173) => 'I',chr(225).chr(188).chr( 174) => 'I',
			chr(225).chr(188).chr( 175) => 'I',chr(225).chr(190).chr( 152) => 'I',
			chr(225).chr(190).chr( 153) => 'I',chr(225).chr(190).chr( 154) => 'I',
			chr(225).chr(190).chr( 155) => 'I',chr(225).chr(190).chr( 156) => 'I',
			chr(225).chr(190).chr( 157) => 'I',chr(225).chr(190).chr( 158) => 'I',
			chr(225).chr(190).chr( 159) => 'I',chr(225).chr(191).chr( 138) => 'I',
			chr(225).chr(191).chr( 139) => 'I',chr(225).chr(191).chr( 140) => 'I',
			chr(206).chr(152) => 'TH',chr(206).chr(153) => 'I',
			chr(206).chr(138) => 'I',chr(206).chr(170) => 'I',
			chr(225).chr(188).chr( 184) => 'I',chr(225).chr(188).chr( 185) => 'I',
			chr(225).chr(188).chr( 186) => 'I',chr(225).chr(188).chr( 187) => 'I',
			chr(225).chr(188).chr( 188) => 'I',chr(225).chr(188).chr( 189) => 'I',
			chr(225).chr(188).chr( 190) => 'I',chr(225).chr(188).chr( 191) => 'I',
			chr(225).chr(191).chr( 152) => 'I',chr(225).chr(191).chr( 153) => 'I',
			chr(225).chr(191).chr( 154) => 'I',chr(225).chr(191).chr( 155) => 'I',
			chr(206).chr(154) => 'K',chr(206).chr(155) => 'L',
			chr(206).chr(156) => 'M',chr(206).chr(157) => 'N',
			chr(206).chr(158) => 'KS',chr(206).chr(159) => 'O',
			chr(206).chr(140) => 'O',chr(225).chr(189).chr( 136) => 'O',
			chr(225).chr(189).chr( 137) => 'O',chr(225).chr(189).chr( 138) => 'O',
			chr(225).chr(189).chr( 139) => 'O',chr(225).chr(189).chr( 140) => 'O',
			chr(225).chr(189).chr( 141) => 'O',chr(225).chr(191).chr( 184) => 'O',
			chr(225).chr(191).chr( 185) => 'O',chr(206).chr(160) => 'P',
			chr(206).chr(161) => 'R',chr(225).chr(191).chr( 172) => 'R',
			chr(206).chr(163) => 'S',chr(206).chr(164) => 'T',
			chr(206).chr(165) => 'Y',chr(206).chr(142) => 'Y',
			chr(206).chr(171) => 'Y',chr(225).chr(189).chr( 153) => 'Y',
			chr(225).chr(189).chr( 155) => 'Y',chr(225).chr(189).chr( 157) => 'Y',
			chr(225).chr(189).chr( 159) => 'Y',chr(225).chr(191).chr( 168) => 'Y',
			chr(225).chr(191).chr( 169) => 'Y',chr(225).chr(191).chr( 170) => 'Y',
			chr(225).chr(191).chr( 171) => 'Y',chr(206).chr(166) => 'F',
			chr(206).chr(167) => 'X',chr(206).chr(168) => 'PS',
			chr(206).chr(169) => 'O',chr(206).chr(143) => 'O',
			chr(225).chr(189).chr( 168) => 'O',chr(225).chr(189).chr( 169) => 'O',
			chr(225).chr(189).chr( 170) => 'O',chr(225).chr(189).chr( 171) => 'O',
			chr(225).chr(189).chr( 172) => 'O',chr(225).chr(189).chr( 173) => 'O',
			chr(225).chr(189).chr( 174) => 'O',chr(225).chr(189).chr( 175) => 'O',
			chr(225).chr(190).chr( 168) => 'O',chr(225).chr(190).chr( 169) => 'O',
			chr(225).chr(190).chr( 170) => 'O',chr(225).chr(190).chr( 171) => 'O',
			chr(225).chr(190).chr( 172) => 'O',chr(225).chr(190).chr( 173) => 'O',
			chr(225).chr(190).chr( 174) => 'O',chr(225).chr(190).chr( 175) => 'O',
			chr(225).chr(191).chr( 186) => 'O',chr(225).chr(191).chr( 187) => 'O',
			chr(225).chr(191).chr( 188) => 'O',chr(206).chr(177) => 'a',
			chr(206).chr(172) => 'a',chr(225).chr(188).chr( 128) => 'a',
			chr(225).chr(188).chr( 129) => 'a',chr(225).chr(188).chr( 130) => 'a',
			chr(225).chr(188).chr( 131) => 'a',chr(225).chr(188).chr( 132) => 'a',
			chr(225).chr(188).chr( 133) => 'a',chr(225).chr(188).chr( 134) => 'a',
			chr(225).chr(188).chr( 135) => 'a',chr(225).chr(190).chr( 128) => 'a',
			chr(225).chr(190).chr( 129) => 'a',chr(225).chr(190).chr( 130) => 'a',
			chr(225).chr(190).chr( 131) => 'a',chr(225).chr(190).chr( 132) => 'a',
			chr(225).chr(190).chr( 133) => 'a',chr(225).chr(190).chr( 134) => 'a',
			chr(225).chr(190).chr( 135) => 'a',chr(225).chr(189).chr( 176) => 'a',
			chr(225).chr(189).chr( 177) => 'a',chr(225).chr(190).chr( 176) => 'a',
			chr(225).chr(190).chr( 177) => 'a',chr(225).chr(190).chr( 178) => 'a',
			chr(225).chr(190).chr( 179) => 'a',chr(225).chr(190).chr( 180) => 'a',
			chr(225).chr(190).chr( 182) => 'a',chr(225).chr(190).chr( 183) => 'a',
			chr(206).chr(178) => 'b',chr(206).chr(179) => 'g',
			chr(206).chr(180) => 'd',chr(206).chr(181) => 'e',
			chr(206).chr(173) => 'e',chr(225).chr(188).chr( 144) => 'e',
			chr(225).chr(188).chr( 145) => 'e',chr(225).chr(188).chr( 146) => 'e',
			chr(225).chr(188).chr( 147) => 'e',chr(225).chr(188).chr( 148) => 'e',
			chr(225).chr(188).chr( 149) => 'e',chr(225).chr(189).chr( 178) => 'e',
			chr(225).chr(189).chr( 179) => 'e',chr(206).chr(182) => 'z',
			chr(206).chr(183) => 'i',chr(206).chr(174) => 'i',
			chr(225).chr(188).chr( 160) => 'i',chr(225).chr(188).chr( 161) => 'i',
			chr(225).chr(188).chr( 162) => 'i',chr(225).chr(188).chr( 163) => 'i',
			chr(225).chr(188).chr( 164) => 'i',chr(225).chr(188).chr( 165) => 'i',
			chr(225).chr(188).chr( 166) => 'i',chr(225).chr(188).chr( 167) => 'i',
			chr(225).chr(190).chr( 144) => 'i',chr(225).chr(190).chr( 145) => 'i',
			chr(225).chr(190).chr( 146) => 'i',chr(225).chr(190).chr( 147) => 'i',
			chr(225).chr(190).chr( 148) => 'i',chr(225).chr(190).chr( 149) => 'i',
			chr(225).chr(190).chr( 150) => 'i',chr(225).chr(190).chr( 151) => 'i',
			chr(225).chr(189).chr( 180) => 'i',chr(225).chr(189).chr( 181) => 'i',
			chr(225).chr(191).chr( 130) => 'i',chr(225).chr(191).chr( 131) => 'i',
			chr(225).chr(191).chr( 132) => 'i',chr(225).chr(191).chr( 134) => 'i',
			chr(225).chr(191).chr( 135) => 'i',chr(206).chr(184) => 'th',
			chr(206).chr(185) => 'i',chr(206).chr(175) => 'i',
			chr(207).chr(138) => 'i',chr(206).chr(144) => 'i',
			chr(225).chr(188).chr( 176) => 'i',chr(225).chr(188).chr( 177) => 'i',
			chr(225).chr(188).chr( 178) => 'i',chr(225).chr(188).chr( 179) => 'i',
			chr(225).chr(188).chr( 180) => 'i',chr(225).chr(188).chr( 181) => 'i',
			chr(225).chr(188).chr( 182) => 'i',chr(225).chr(188).chr( 183) => 'i',
			chr(225).chr(189).chr( 182) => 'i',chr(225).chr(189).chr( 183) => 'i',
			chr(225).chr(191).chr( 144) => 'i',chr(225).chr(191).chr( 145) => 'i',
			chr(225).chr(191).chr( 146) => 'i',chr(225).chr(191).chr( 147) => 'i',
			chr(225).chr(191).chr( 150) => 'i',chr(225).chr(191).chr( 151) => 'i',
			chr(206).chr(186) => 'k',chr(206).chr(187) => 'l',
			chr(206).chr(188) => 'm',chr(206).chr(189) => 'n',
			chr(206).chr(190) => 'ks',chr(206).chr(191) => 'o',
			chr(207).chr(140) => 'o',chr(225).chr(189).chr( 128) => 'o',
			chr(225).chr(189).chr( 129) => 'o',chr(225).chr(189).chr( 130) => 'o',
			chr(225).chr(189).chr( 131) => 'o',chr(225).chr(189).chr( 132) => 'o',
			chr(225).chr(189).chr( 133) => 'o',chr(225).chr(189).chr( 184) => 'o',
			chr(225).chr(189).chr( 185) => 'o',chr(207).chr(128) => 'p',
			chr(207).chr(129) => 'r',chr(225).chr(191).chr( 164) => 'r',
			chr(225).chr(191).chr( 165) => 'r',chr(207).chr(131) => 's',
			chr(207).chr(130) => 's',chr(207).chr(132) => 't',
			chr(207).chr(133) => 'y',chr(207).chr(141) => 'y',
			chr(207).chr(139) => 'y',chr(206).chr(176) => 'y',
			chr(225).chr(189).chr( 144) => 'y',chr(225).chr(189).chr( 145) => 'y',
			chr(225).chr(189).chr( 146) => 'y',chr(225).chr(189).chr( 147) => 'y',
			chr(225).chr(189).chr( 148) => 'y',chr(225).chr(189).chr( 149) => 'y',
			chr(225).chr(189).chr( 150) => 'y',chr(225).chr(189).chr( 151) => 'y',
			chr(225).chr(189).chr( 186) => 'y',chr(225).chr(189).chr( 187) => 'y',
			chr(225).chr(191).chr( 160) => 'y',chr(225).chr(191).chr( 161) => 'y',
			chr(225).chr(191).chr( 162) => 'y',chr(225).chr(191).chr( 163) => 'y',
			chr(225).chr(191).chr( 166) => 'y',chr(225).chr(191).chr( 167) => 'y',
			chr(207).chr(134) => 'f',chr(207).chr(135) => 'x',
			chr(207).chr(136) => 'ps',chr(207).chr(137) => 'o',
			chr(207).chr(142) => 'o',chr(225).chr(189).chr( 160) => 'o',
			chr(225).chr(189).chr( 161) => 'o',chr(225).chr(189).chr( 162) => 'o',
			chr(225).chr(189).chr( 163) => 'o',chr(225).chr(189).chr( 164) => 'o',
			chr(225).chr(189).chr( 165) => 'o',chr(225).chr(189).chr( 166) => 'o',
			chr(225).chr(189).chr( 167) => 'o',chr(225).chr(190).chr( 160) => 'o',
			chr(225).chr(190).chr( 161) => 'o',chr(225).chr(190).chr( 162) => 'o',
			chr(225).chr(190).chr( 163) => 'o',chr(225).chr(190).chr( 164) => 'o',
			chr(225).chr(190).chr( 165) => 'o',chr(225).chr(190).chr( 166) => 'o',
			chr(225).chr(190).chr( 167) => 'o',chr(225).chr(189).chr( 188) => 'o',
			chr(225).chr(189).chr( 189) => 'o',chr(225).chr(191).chr( 178) => 'o',
			chr(225).chr(191).chr( 179) => 'o',chr(225).chr(191).chr( 180) => 'o',
			chr(225).chr(191).chr( 182) => 'o',chr(225).chr(191).chr( 183) => 'o',
			chr(206).chr(132) => '',chr(194).chr(168) => '',
			chr(206).chr(133) => '',chr(225).chr(190).chr( 191) => '',
			chr(225).chr(191).chr( 190) => '',chr(225).chr(191).chr( 141) => '',
			chr(225).chr(191).chr( 157) => '',chr(225).chr(191).chr( 142) => '',
			chr(225).chr(191).chr( 158) => '',chr(225).chr(191).chr( 143) => '',
			chr(225).chr(191).chr( 159) => '',chr(225).chr(191).chr( 128) => '',
			chr(225).chr(191).chr( 129) => '',chr(206).chr(132) => '',
			chr(225).chr(191).chr( 174) => '',chr(225).chr(191).chr( 175) => '',
			chr(225).chr(191).chr( 173) => '',chr(205).chr(186) => '',
			chr(225).chr(190).chr( 189) => '',
                        );
	                    $name = strtr($name, $chars);
	                }
	                 
	                $chars = array(chr(195).chr(128) => 'A', chr(195).chr(129) => 'A',
	                    chr(195).chr(130) => 'A', chr(195).chr(131) => 'A',
	                    chr(195).chr(132) => 'A', chr(195).chr(133) => 'A',
	                    chr(195).chr(135) => 'C', chr(195).chr(136) => 'E',
	                    chr(195).chr(137) => 'E', chr(195).chr(138) => 'E',
	                    chr(195).chr(139) => 'E', chr(195).chr(140) => 'I',
	                    chr(195).chr(141) => 'I', chr(195).chr(142) => 'I',
	                    chr(195).chr(143) => 'I', chr(195).chr(145) => 'N',
	                    chr(195).chr(146) => 'O', chr(195).chr(147) => 'O',
	                    chr(195).chr(148) => 'O', chr(195).chr(149) => 'O',
	                    chr(195).chr(150) => 'O', chr(195).chr(153) => 'U',
	                    chr(195).chr(154) => 'U', chr(195).chr(155) => 'U',
	                    chr(195).chr(156) => 'U',	 chr(195).chr(157) => 'Y',
	                    chr(195).chr(159) => 'ss',
	                    chr(195).chr(160) => 'a', chr(195).chr(161) => 'a',
	                    chr(195).chr(162) => 'a', chr(195).chr(163) => 'a',
	                    chr(195).chr(164) => 'a', chr(195).chr(165) => 'a',
	                    chr(195).chr(167) => 'c', chr(195).chr(168) => 'e',
	                    chr(195).chr(169) => 'e', chr(195).chr(170) => 'e',
	                    chr(195).chr(171) => 'e', chr(195).chr(172) => 'i',
	                    chr(195).chr(173) => 'i', chr(195).chr(174) => 'i',
	                    chr(195).chr(175) => 'i', chr(195).chr(177) => 'n',
	                    chr(195).chr(178) => 'o', chr(195).chr(179) => 'o',
	                    chr(195).chr(180) => 'o', chr(195).chr(181) => 'o',
	                    chr(195).chr(182) => 'o', chr(195).chr(182) => 'o',
	                    chr(195).chr(185) => 'u', chr(195).chr(186) => 'u',
	                    chr(195).chr(187) => 'u', chr(195).chr(188) => 'u',
	                    chr(195).chr(189) => 'y', chr(195).chr(191) => 'y',
	                    chr(196).chr(140) => 'C', chr(196).chr(141) => 'c',
	                    chr(196).chr(142) => 'D', chr(196).chr(143) => 'd',
	                    chr(196).chr(154) => 'E', chr(196).chr(155) => 'e',
	                    chr(196).chr(158) => 'G', chr(196).chr(159) => 'g',
	                    chr(196).chr(176) => 'I', chr(196).chr(177) => 'i',

	                    chr(197).chr(135) => 'N', chr(197).chr(136) => 'n',
	                    chr(197).chr(146) => 'OE', chr(197).chr(147) => 'oe',
	                    chr(197).chr(152) => 'R', chr(197).chr(153) => 'r',
	                    chr(197).chr(152) => 'R', chr(197).chr(153) => 'r',
	                    chr(197).chr(158) => 'S', chr(197).chr(159) => 's',
	                    chr(197).chr(160) => 'S', chr(197).chr(161) => 's',
	                    chr(197).chr(164) => 'T', chr(197).chr(165) => 't',
	                    chr(197).chr(174) => 'U', chr(197).chr(175) => 'u',
	                    chr(197).chr(189) => 'Z', chr(197).chr(190) => 'z',
	                    chr(226).chr(130).chr(172) => 'euro',
	                    chr(226).chr(128).chr(185) => '',
	                    chr(226).chr(128).chr(186) => '',
	                    chr(226).chr(128).chr(156) => '',
	                    chr(226).chr(128).chr(157) => '',
	                    chr(226).chr(128).chr(153) => '',
	                    chr(194).chr(171) => '',
	                    chr(194).chr(174) => '',
	                    chr(194).chr(187) => '',
	                    chr(194).chr(180) => '',
	                    chr(194).chr(191) => '',
	                    chr(194).chr(161) => '',
	                    chr(216).chr(159) => '', //arabic ?
			    chr(194).chr(169) => 'copyright', //copyrigth
			    chr(195).chr(134) => 'i',chr(195).chr(174) => 'i',//romanian characters
			    chr(196).chr(129) => 'a',chr(196).chr(130) => 'a',chr(196).chr(131) => 'a',
			    chr(197).chr(162) => 't',chr(197).chr(163) => 't',
	                );
	                $name = strtr($name, $chars);
	                $name = str_replace("ia", "i", $name);//strange smf encoding ?
	            }
	            else
	            {
	                $chars['in'] = chr(128).chr(131).chr(138).chr(142).chr(154).chr(158)
	                .chr(159).chr(162).chr(165).chr(181).chr(192).chr(193).chr(194)
	                .chr(195).chr(196).chr(197).chr(199).chr(200).chr(201).chr(202)
	                .chr(203).chr(204).chr(205).chr(206).chr(207).chr(209).chr(210)
	                .chr(211).chr(212).chr(213).chr(214).chr(216).chr(217).chr(218)
	                .chr(219).chr(220).chr(221).chr(224).chr(225).chr(226).chr(227)
	                .chr(228).chr(229).chr(231).chr(232).chr(233).chr(234).chr(235)
	                .chr(236).chr(237).chr(238).chr(239).chr(241).chr(242).chr(243)
	                .chr(244).chr(245).chr(246).chr(248).chr(249).chr(250).chr(251)
	                .chr(252).chr(253).chr(255);
	                 
	                $chars['out'] = "EfSZszYcYuAAAAAACEEEEIIIINOOOOOOUUUUYaaaaaaceeeeiiiinoooooouuuuyy";
	                if ($context['character_set'] == "ISO-8859-9") // turkish
	                {
	                    $name = strtr($name, chr(254).chr(222).chr(240).chr(208).chr(253).chr(221).chr(246).chr(214).chr(252).chr(220), 'sSgGiIoOuU');
	                }
	                 
	                if ($context['character_set'] == "ISO-8859-1") //umlauts german
	                {
	                    $name = strtr($name, array(chr(228) => 'ae', chr(196) => 'ae', chr(246) => 'oe', chr(214) => 'oe', chr(220) => 'ue', chr(252) => 'ue', chr(223) => 'ss'));
	                }
	                 
	                if ($context['character_set'] == "ISO-8859-2") // Polish
	                {
	                    $name = strtr($name, chr(161).chr(177).chr(198).chr(230).chr(202).chr(234).chr(163).chr(179).chr(209).chr(241).chr(211).chr(243).chr(166).chr(182).chr(175).chr(191).chr(172).chr(188), 'AaCcEeLlNnOoSsZzZz');
	                }
	                 
	                $name = strtr($name, array(chr(171) => '', chr(187) => ''));
	                 
	                $name = strtr($name, $chars['in'], $chars['out']);
	                 
	                $double_chars['in'] = array(chr(140), chr(156), chr(198), chr(208), chr(222), chr(223), chr(230), chr(240), chr(254));
	                $double_chars['out'] = array('OE', 'oe', 'AE', 'DH', 'TH', 'ss', 'ae', 'dh', 'th');
	                $name = str_replace($double_chars['in'], $double_chars['out'], $name);
	            }
	             
	        }
	    }
	     
	     
	    $name = strtolower(htmlentities($name));
	    $name = preg_replace("/&(.)(uml);/", "$1e", $name);
	    $name = preg_replace("/&(.)(acute|cedil|circ|ring|tilde|uml);/", "$1", $name);
	    $name = strtr($name, array('&quot;' => ';', '&amp;' => '&'));
	    $name = strtr($name, array('&euro;' => 'euro', '&#8364;' => 'euro'));
	     
	    $signs = array("Re :", "Re:", "re:", "re :","~", "`", "!", "@", "#", "$", "%", "^", "&", "*", "(", ")", "_", "+", "|", "\\", "=", "-", "{", "}", "[", "]", ":", "\"", ";", "'", "<", ">", "?", ",", ".", "/","°","º","","©","®","","","","æ","","","","±","·","","¯");
	    $name = str_replace($signs, "", un_htmlspecialchars($name));
	    $name = trim($name);
	     
	    //replace multiple spaces with single spaces
	    $name = preg_replace('/\s\s+/', ' ', $name);
	     
	    return $name;
	}


	function scan_boards($boards, $board_id)
	{
	    global $modSettings;
	    $board_name = "";
	     
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($boards as $board)
	    {
	        if ($board['id'] == $board_id)
	        {
	            $name = remove_signs($board['name']);
	            $board_name = strtolower(str_replace(" ", $split_char, $name));
	            return $board_name;
	        }
	         
	        if (!empty($board['children']))
	        {
	             
	            $board_name = scan_boards($board['children'], $board_id);
	            if ($board_name != "")
	            {
	                //$name=trim($board['name']);
	                //$t=strtolower(str_replace(" ",$split_char,$name))."/".$board_name;
	                $t = $board_name;
	                return $t;
	            }
	        }
	    }
	     
	    return $board_name;
	}
	 
	function scan_topics($topics, $topic_id)
	{
	    global $modSettings;
	    $topic_name = "";
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($topics as $topic)
	    {
	        if ($topic['id'] == $topic_id)
	        {
	            if (isset($topic['subject']))
	            {
	                $subject = remove_signs($topic['subject']);
	                $subject = str_replace(" ", $split_char, $subject);
	                $topic_name = strtolower($subject);
	            }
	            return $topic_name;
	        }
	    }
	     
	    return $topic_name;
	}
	 
	function scan_unread_topics($topics, $topic_id)
	{
	    global $modSettings;
	    $topic_name = "";
	    $board_name = "";
	    $board_topic = "";
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($topics as $topic)
	    {
	        if ($topic['id'] == $topic_id)
	        {
	            $subject = remove_signs($topic['first_post']['subject']);
	            $subject = str_replace(" ", $split_char, $subject);
	            $topic_name = strtolower($subject);
	            return $topic_name;
	        }
	    }
	     
	    return $topic_name;
	}



	function scan_posts($topics, $topic_id)
	{
	    global $modSettings;
	    $topic_name = "";
	    $board_name = "";
	     
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($topics as $topic)
	    {
	        if (isset($topic['topic']))
	            if ($topic['topic'] == $topic_id)
	        {
	            $subject = remove_signs($topic['subject']);
	            $subject = str_replace(" ", $split_char, $subject);
	            $topic_name = strtolower($subject);

	            return $topic_name;
	        }
	    }
	     
	    return $topic_name;
	}
	 
	function scan_post_boards($topics, $board_id)
	{
	    global $modSettings;
	    $topic_name = "";
	    $board_name = "";
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($topics as $topic)
	    {
	        if ($topic['board']['id'] == $board_id)
	        {
	            if (isset($topic['board']))
	            {
	                $board_name = remove_signs($topic['board']['name']);
	                $board_name = str_replace(" ", $split_char, $board_name);
	                $board_name = strtolower($board_name);
	            }
	            return $board_name;
	        }
	    }
	     
	    return $board_name;
	}
	 
	 
	function scan_recent_topics($topics, $topic_id)
	{
	    global $modSettings;
	    $topic_name = "";
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    if (!empty($topics))
	        foreach($topics as $topic)
	    {
	        if ($topic['topic'] == $topic_id)
	        {
	            $subject = remove_signs($topic['subject']);
	             
	            $subject = str_replace(" ", $split_char, $subject);
	            $topic_name = strtolower($subject);
	                return $topic_name;
	        }
	    }
	     
	    return $topic_name;
	}
	 
	function the_ultimate_solution_topic($topic_id)
	{
	    global $smcFunc, $db_prefix, $modSettings;
	    $path_name = "";
	    $count = 0;
	    $board_name = "";
	     
	    //$oldlevel = error_reporting(E_ALL);
	    //user_error('SQL Query for Topic topic_id='.$topic_id,E_USER_WARNING);
	    //error_reporting($oldlevel);
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";

$topic_id = (int)$topic_id;

	   $topic_result =  $smcFunc['db_query']('', '
	      SELECT id_topic, subject
	      FROM {db_prefix}messages
	      WHERE id_topic = {int:topic}
	      LIMIT 1',
	      array(
			'topic' => $topic_id,
	      )
	   );
	   $context['new_topic'] = array();
	   while ($row_topic = $smcFunc['db_fetch_assoc']($topic_result))
	   {
	      $context['new_topic'][] = array(
	         'subject' => $row_topic['subject'],
	         'id' => $row_topic['id_topic'],
	      );
	   }
	   $smcFunc['db_free_result']($topic_result);

		foreach ($context['new_topic'] as $hhytopic)
		{
		        $path_name = remove_signs($hhytopic['subject']);
		        $path_name = strtolower(str_replace(" ", $split_char, $path_name));
		}

	    return $path_name;
	}
	 
	function the_ultimate_solution_board($board_id)
	{
	    global $smcFunc, $db_prefix, $modSettings;
	    $path_name = "";
	    $count = 0;
	    //$oldlevel = error_reporting(E_ALL);
	    //user_error('SQL Query for Board board_id='.$board_id,E_USER_WARNING);
	    //error_reporting($oldlevel);
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";

	   $board_result =  $smcFunc['db_query']('', '
	      SELECT id_board, name
	      FROM {db_prefix}boards
	      WHERE id_board = {int:board}
	      LIMIT 1',
	      array(
		'board' => $board_id,
	      )
	   );
	   $context['new_board'] = array();
	   while ($row_board = $smcFunc['db_fetch_assoc']($board_result))
	   {
	      $context['new_board'][] = array(
	         'name' => $row_board['name'],
	         'id' => $row_board['id_board'],
	      );
	   }
	   $smcFunc['db_free_result']($board_result);

		foreach ($context['new_board'] as $hhyboard)
		{
		        $path_name = remove_signs($hhyboard['name']);
		        $path_name = strtolower(str_replace(" ", $split_char, $path_name));
		}

		if (empty($path_name)) $path_name="empty";
	     
	    return $path_name;
	}
	 
	function scan_topic_path($paths)
	{
	    global $modSettings;
	    $path_name = "";
	    $count = 0;
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($paths as $path)
	    {
	        if ($count > count($paths)-2)
	        {
	            $name = remove_signs($path['name']);
	            $path_name .= strtolower(str_replace(" ", $split_char, $name));
	            $path_name .= '/';
	        }
	        $count++;
	    }
	     
	    return $path_name;
	}
	 
	function scan_last_post($boards, $topic_id)
	{
	    global $modSettings;
	    $path_name = "";
	    $topic_name = "";
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($boards as $board)
	    {
	        if (isset($board['last_post']['topic']))
	            if ($board['last_post']['topic'] == $topic_id)
	        {
	            $subject = remove_signs($board['last_post']['long_subject']);
	            $subject = str_replace(" ", $split_char, $subject);
	            $topic_name = strtolower($subject);
	            return $topic_name;
	        }
	    }
	     
	    return $path_name;
	}
	 
	function scan_path($paths, $id)
	{
	    global $modSettings;
	    $path_name = "";
	    $count = 0;
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($paths as $path)
	    {
	        if ($count > count($paths)-3)
	        {
	            $name = remove_signs($path['name']);
	            if (isset($modSettings['seo4smf_board_topic']))
	                $board_topic = $modSettings['seo4smf_board_topic'];
	            if ($board_topic != "on")
	            {
	                $path_name .= strtolower(str_replace(" ", $split_char, $name));
	                if (isset($path['id']))
	                    if ($path['id'] == $id) return $path_name;
	                $path_name .= '/';
	            }
	            else
	            {
	                $path_name = strtolower(str_replace(" ", $split_char, $name));
	                if (isset($path['id']))
	                    if ($path['id'] == $id) return $path_name;
	                $path_name .= '/';
	            }
	        }
	        $count++;
	    }
	     
	    return $path_name;
	}
	 
	function scan_pathb($paths, $id)
	{
	    global $modSettings;
	    $path_name = "";
	    $count = 0;
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($paths as $path)
	    {
	        if ($count > count($paths)-4)
	        {
	            if (isset($path['id']))
	                if ($path['id'] == $id)
	            {
	                $name = remove_signs($path['name']);
	                $path_name = strtolower(str_replace(" ", $split_char, $name));
	                return $path_name;
	            }
	            //     $path_name.='/';
	        }
	        $count++;
	    }
	     
	    return $path_name;
	}
	 
	function scan_topic_results($topics, $topic_id)
	{
	    global $modSettings;
	    $path_name = "";
	    $board_topic = "";
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($topics as $topic)
	    {
	        if ($topic['id'] == $topic_id)
	        {
	            $path_name = remove_signs($topic['subject']);
	            $path_name = strtolower(str_replace(" ", $split_char, $path_name));
	             
	            //$path_name$topic['subject'];
	            return $path_name;
	        }
	    }
	    return $path_name;
	}
	 
	function scan_board_results($topics, $board_id)
	{
	    global $modSettings;
	    $path_name = "";
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($topics as $topic)
	    {
	        if ($topic['board_id'] == $board_id)
	        {
	            $board_name = remove_signs($topic['board_name']);
	            $board_name = strtolower(str_replace(" ", $split_char, $board_name));
	            //$path_name$topic['subject'];
	            return $board_name;
	        }
	    }
	    return $path_name;
	}
	 
	function scan_board_news($topics, $topic_id)
	{
	    global $modSettings;
	    $path_name = "";
	    $board_name = "";
	    $board_topic = "";
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    foreach($topics as $topic)
	    {
	        if ($topic['id'] == $topic_id)
	        {
	            $path_name = remove_signs($topic['subject']);
	            $path_name = strtolower(str_replace(" ", $split_char, $path_name));
	             
	            //$path_name$topic['subject'];
	            return $path_name;
	        }
	    }
	    return $path_name;
	}
	 
	function beautify_urls($bt)
	{
	    global $scripturl, $modSettings, $user_info, $context;
	    if (isset($modSettings['seo4smf_split_char']))
	        $split_char = $modSettings['seo4smf_split_char'];
	    else
	        $split_char = "_";
	     
	    $board_name = "";
	    $board_id = "";
	    $topic_id = "";
	    $otype = "";
	    $oid = "";
	    //$board_id=substr($bt,strpos($bt,",")+1);
	    $oldbt = $bt;
	    $oldlevel = error_reporting(0);
	     
	     
	    if (strpos("/", $bt) === false)
	    {
	        list($bt, $other, $other2) = explode("/", $bt);
	        list($type, $id) = explode(",", $bt);
	    }
	    else
	        list($type, $id) = explode(",", $bt);
	     
	    if ($other != "")
	    {
	        list($otype, $oid) = explode(",", $other);
	         
	        if (($otype == "boardseen") || ($otype == "topicseen"))
	            $other = ";".$otype.$oid;
	        else
	            $other = ";".$otype.'='.$oid;
	         
	        if ($other2 != "")
	            $other .= ";".$other2;
	    }
	     
	    if ($type == "board")
	        $board_id = $id;
	     
	    if ($type == "topic")
	        $topic_id = $id;
	     
	    if ($type == "page")
	        $tpage_id = $id;
	     
	    list($board_id, $sboard_id) = explode(".", $board_id);
	    list($topic_id, $stopic_id) = explode(".", $topic_id);
	     
	    if (isset($modSettings['seo4smf_board_topic']))
	        $board_topic = $modSettings['seo4smf_board_topic'];
	     
	     
	    if ($type == "board")
	    {
	        if (!empty($context['categories']))
	        {
	            foreach($context['categories'] as $categorie)
	            {
	                $board_name = scan_boards($categorie['boards'], $board_id);
	                if ($board_name != "") break;
	            }
	            if (empty($board_name) && ($modSettings['seo4smf_sql_enable'] == "on"))
	            {
	                $board_name = the_ultimate_solution_board($board_id);
	            }
	            $id .= "/";
	            return $board_name."-b".$id.$other;
	        }
	        else
	        {
	            if (!empty($context['boards']))
	            {
	                $path_name = scan_pathb($context['linktree'], $board_id); //topic_path
	                $board_name = scan_boards($context['boards'], $board_id);
	                $id .= "/";
	                 
	                if (empty($board_name))
	                    return $path_name."-b".$id.$other;
	                else
	                    return $board_name."-b".$id.$other;
	            }
	            else
	            {
	                $path_name = scan_pathb($context['linktree'], $board_id);
	                 
	                if ($context['current_action'] == "search2")
	                {
	                    //$path_name=substr($path_name,0,-1);
	                    $path_name = scan_board_results($context['search_results'], $board_id);
	                }
	                 
	                if (!empty($context['topics'])) //we have unread replies
	                {
	                    foreach($context['topics'] as $topic)
	                    {
	                        if (isset($topic['board']))
	                            if ($topic['board']['id'] == $board_id)
	                        {
	                            $name = remove_signs($topic['board']['name']);
	                            $board_name = strtolower(str_replace(" ", $split_char, $name));
	                            $path_name = "";
	                            //return $board_name;
	                        }
	                    }
	                }
	                if (isset($context['posts']))
	                    $path_name = scan_post_boards($context['posts'], $board_id);
	                 
	                if (empty($path_name) && ($modSettings['seo4smf_sql_enable'] == "on"))
	                {
	                    $board_name = the_ultimate_solution_board($board_id);
	                }
	                 
	                if (!is_numeric($sboard_id))
	                {
	                    $id = $board_id.".0/";
	                }
	                else
	                {
	                    $id .= "/";
	                }
	                 
	                 
	                return $path_name.$board_name."-b".$id.$other;
	            }
	        }
	         
	    }
	     
	    if ($type == "topic")
	    {
	        if ((!empty($context['topics'])) && ($otype != "topicseen"))
	        {
	            $path_name = scan_topic_path($context['linktree']);
	            $topic_name = scan_topics($context['topics'], $topic_id);
	             
	            if ($stopic_id == "0")
	            {
	                if ($context['current_action'] == "search2")
	                {
	                    $path_name = scan_topic_results($context['search_results'], $topic_id);
	                }
	            }
	            else
	            {
	                 
	                if ($context['current_action'] == "search2")
	                {
	                    $path_name = scan_topic_results($context['search_results'], $topic_id);
	                }
	                 
	                if ((!empty($context['boards'])) && ($otype != "topicseen"))
	                {
	                    if ($board_topic != "on")
	                    {
	                        if ($topic_name == "")
	                            $path_name = scan_last_post($context['boards'], $topic_id);
	                    }
	                    else
	                        $topic_name = scan_last_post($context['boards'], $topic_id);
	                     
	                }
	            }
	             
	            if (!is_numeric($stopic_id))
	            {
	                $id = $topic_id.".0.html;".$stopic_id;
	            }
	            else
	            {
	                $id .= ".html";
	            }
	             
	            if ($board_topic != "on")
	                $path_name = $path_name.$topic_name;
	            else
	                $path_name = $topic_name;
	             
	            if (($path_name[strlen($path_name)-1] == "/") || ($path_name == ""))
	            {
	                $topic_id = (int)$topic_id;
	                $path_name = the_ultimate_solution_topic($topic_id);
	            }
	             
	            return $path_name."-t".$id.$other;
	        }
	        else
	        {
	            $path_name = scan_path($context['linktree'], 't'.$topic_id);
	             
	            if ((!empty($context['boards'])) && ($otype != "topicseen"))
	            {
	                $path_name = scan_last_post($context['boards'], $topic_id);
	            }
	            else
	            {
	                if ((!empty($context['categories'])) && ($otype != "topicseen"))
	                {
	                    foreach($context['categories'] as $categorie)
	                    {
	                        $result = scan_last_post($categorie['boards'], $topic_id);
	                         
	                        if ($result != "")
	                        {
	                            $path_name = $result;
	                            break;
	                        }
	                    }
	                }
	                else
	                {
	                    if ($otype == "topicseen") //we have a tiny portal here or unread replys
	                    {
	                        if (!empty($context['topics']))
	                        {
	                            if (isset($context['recent_topics']))
	                            {
	                                $path_name = scan_recent_topics($context['recent_topics'], $topic_id);
	                            }
	                            if (($path_name == "") && isset($context['topics']))
	                            {
	                                $path_name = scan_unread_topics($context['topics'], $topic_id);
	                            }
	                             
	                        }
	                        else
	                        {
	                            if (isset($context['recent_topics']))
	                                $path_name = scan_recent_topics($context['recent_topics'], $topic_id);
	                             
	                            if ((($path_name == "") || ($path_name[strlen($path_name)-1] == "/")) && (isset($context['latest_posts'])))
	                            {
	                                $path_name = scan_recent_topics($context['latest_posts'], $topic_id);
	                            }
	                        }
	                         
	                    }
	                    else
	                    {
	                        if (isset($context['TPortal']['boardnews']))
	                            $path_name = scan_board_news($context['TPortal']['boardnews'], $topic_id);
	                         
	                        if (isset($context['posts']))
	                            $path_name = scan_posts($context['posts'], $topic_id);
	                         
	                        if ($context['current_action'] == "search2")
	                        {
	                            $path_name = scan_topic_results($context['search_results'], $topic_id);
	                        }
	                         
	                    }
	                     
	                }
	                 
	            }
	             
	             
	            if ((($path_name[strlen($path_name)-1] == "/") || ($path_name == "")) && ($modSettings['seo4smf_sql_enable'] == "on"))
	            {
	                $path_name = the_ultimate_solution_topic($topic_id);
	            }
	             
	            if (($path_name[strlen($path_name)-1] == "/") || ($path_name == ""))
	            {
	                $path_name = "empty";
	            }
	             
	            if (!is_numeric($stopic_id))
	            {
	                $id = $topic_id.".0.html;".$stopic_id;
	            }
	            else
	            {
	                $id .= ".html";
	            }
	             
	            return $path_name."-t".$id.$other;
	        }
	    }
	    $path_name = "";
	    if (function_exists('TPortal_init'))
	    if ($type == "page") //tinyportal
	    {
		if (is_numeric($tpage_id))
		{

	        if (isset($context['TPortal']))
	        {
	            if (isset($context['TPortal']['boardnews']))
	            {
	                foreach($context['TPortal']['boardnews'] as $bnews)
	                {
	                    if ($bnews['id'] == $tpage_id)
	                    {
	                        $path_name = strip_tags($bnews['subject']);
	                        $path_name = remove_signs($path_name);
	                        $path_name = strtolower(str_replace(" ", $split_char, $path_name));
	                         
	                        return $path_name."-p".$tpage_id.".html";
	                    }
	                }
	            }
	             
	            if ($path_name == "")
	            {
	                $path_name = scan_tp_sql($tpage_id);
	                return $path_name."-p".$tpage_id.".html";
	            }
	             
	        }
	    	} else return "/index.php?dummy=1;page=".$tpage_id;
	    }
	    error_reporting($oldlevel);
	     
	    return "";
	}

	//function get it from http://www.php.net/html_entity_decode
	// by derernst at gmx dot ch
	 
	function unhtmlentities($text, $quote_style = ENT_COMPAT)
	{
	    if (function_exists('html_entity_decode'))
	    {
	        $text = html_entity_decode($text, $quote_style, 'ISO-8859-1'); // NOTE: UTF-8 does not work!
	    }
	    else
	    {
	        $trans_tbl = get_html_translation_table(HTML_ENTITIES, $quote_style);
	        $trans_tbl = array_flip($trans_tbl);
	        $text = strtr($text, $trans_tbl);
	    }
	    $text = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $text);
	    $text = preg_replace('~&#([0-9]+);~e', 'chr("\\1")', $text);
	    return $text;
	}
	
	function create_sb()
	{
	    global $context, $modSettings, $scripturl, $boardurl, $user_info;
	    $seo4smf_urls = '';
	    $url = "";
	    $group = "";
	     
	    if (isset($user_info['groups'][1]))
	        $group = $user_info['groups'][1];
	     
	    if (($user_info['is_admin'] == 1) || ($modSettings['seo4smf_sb_postgroups'] <= $group))
	    {
	        if ($modSettings['seo4smf_enable'] == "on")
	        {
	            if (isset($context['current_topic'])) //just for topics
	            {
	                $scripturl1 = str_replace("/index.php", "", $scripturl);
	                $uri = beautify_urls(strtr('topic='.$context['current_topic'].'.0', '&;=', '//,'));
	                $url = urlencode($scripturl1.'/'.$uri);
	            }
	        }
	        else
	            $url = urlencode($scripturl.'?topic='.$context['current_topic'].'.0');
	         
	        if (!empty($seo4smf_urls)) $seo4smf_urls = '<font size=2><b>Add This Thread To: </b></font>'.$seo4smf_urls;
	         
	        return $seo4smf_urls;
	    }
	     
	    return "";
	}
	 
	 
	function rewrite_comsmf2($buffer)
	{
	    global $scripturl, $modSettings, $user_info, $context, $boarddir;
	     
	    $scripturl1 = str_replace("/index.php", "", $scripturl);
	     
	    if ($modSettings['seo4smf_sb_enable'] == "on")
	    {
	        $buffer = preg_replace('/<!-- Seo4SMF Social Bookmark -->/', create_sb() , $buffer);
	    }
	     
	    if ($modSettings['seo4smf_enable'] == "on")
	    {
	        $buffer = preg_replace('/"' . preg_quote($scripturl, '/') . '\?((?:board|topic|page)=[^#"]+?)(#[^"]*?)?"/e', "'\"' . \$scripturl1 . '/' . beautify_urls(strtr('\$1', '&;=', '//,')) . '\$2\"'", $buffer);
	         
	        if ($modSettings['seo4smf_keywords'] == "on")
	        {
	            $buffer = preg_replace('<meta name="keywords" content=(.*) />', create_keywords() , $buffer);
	        }
	        if ($modSettings['seo4smf_description'] == "on")
	        {
	            $buffer = preg_replace('<meta name="description" content=(.*) />', create_description() , $buffer);
	        }
	        $buffer = preg_replace('/<a href=\"http:\/\/www.simplemachines.org\/about\/copyright.php\" title=\"Free Forum Software\" target=\"_blank\">SMF &copy; 2006, Simple Machines LLC<\/a>/', '<a href="http://www.simplemachines.org/about/copyright.php" title="Free Forum Software" target="_blank">SMF &copy; 2006, Simple Machines LLC</a><br /> <a href="http://www.webmasterstalks.com">Seo4Smf v0.2 &copy; Webmaster\'s Talks</a>' , $buffer);
	    }
	    else
	    {
	        $buffer = preg_replace('/"' . preg_quote($scripturl, '/') . '\?((?:board|topic)=[^#"]+?)(#[^"]*?)?"/e', "'\"' . \$scripturl . '/' . strtr('\$1', '&;=', '//,') . '.html\$2\"'", $buffer);
	    }
	     
	    // Return the changed buffer.
	    return $buffer;
	}
	 
	 
?>
